{-# LANGUAGE OverloadedStrings, DeriveGeneric #-}

module Config where

import Data.Aeson
import Data.Text
import GHC.Generics
import System.FilePath
import qualified Data.ByteString.Lazy as B

data Config = Config
   { confNumFront :: Int
   , confNumRSS :: Int
   , confTitle :: String
   , confDesc :: String
   , confAuthor :: String
   , confEmail :: String
   , confRoot :: String
   } deriving (Show, Generic)

instance FromJSON Config
instance ToJSON Config

configName :: FilePath
configName = "config.json"

getConfig :: FilePath -> IO Config
getConfig dir = do
   c <- (eitherDecode <$> (B.readFile (dir </> configName)))
   case c of
      Left e -> error e
      Right conf -> return conf
